﻿/*
 * Misc.cs - Helper Functions
 * 
 * ShakeIt - Mutation engine for fuzzing
 * Jeremy Brown (jbrown3264/gmail)
 * Nov 2015
 * 
 */

using System;
using System.Collections.Generic;
using System.Security.Cryptography;
using System.Text;

namespace ShakeIt
{
    public class Misc
    {
        public static readonly List<string> WebBlackList = new List<string>
        {
            "html",
            "javascript",
            "script",
            "type",
            "function",
            "jQuery",
            "DOCTYPE",
            "dtd",
            "<!--",
            "-->",
            "www",
        };

        public static readonly List<string> PDFBlackList = new List<string>
        {
            "PDF",
            "EOF"
        };

        public static readonly List<char> TokenIds = new List<char>
        {
            '(',
            ':',
            '=',
            '"',
            '<',
            '.',
            'v',
            'p',
            ')',
        };

        public static void Options()
        {
            Console.WriteLine("\nShakeIt\n");

            Console.WriteLine("Usage: <out-dir> <in-file> <#tc>\n");
            Console.WriteLine(@"Eg.   shakeit.exe C:\tc\test C:\templates\test.html 1000");
        }

        public static string GetSha1(byte[] bytes)
        {
            SHA1 sha1 = new SHA1CryptoServiceProvider();
            
            byte[] hashData;
            try
            {
                hashData = sha1.ComputeHash(bytes);
            }
            catch (Exception error)
            {
                Console.WriteLine("Error: GetSha1() - {0}\n", error.Message);
                return null;
            }

            var hash = new StringBuilder();
            foreach (byte b in hashData)
            {
                string hex = b.ToString("x2");
                hash.Append(hex);
            }

            return hash.ToString();
        }
    }
}
