﻿using System;
using System.Collections.Generic;
using System.IO;
/*
 * Read.cs - Input Consumption
 * 
 * ShakeIt - Mutation engine for fuzzing
 * Jeremy Brown (jbrown3264/gmail)
 * Nov 2015
 * 
 */

namespace ShakeIt
{
    public class Read
    {
        /*
         * For text-based files only
         */
        public static string InputAsString(string fileName, string outDirectory)
        {
            string inputString;
            try
            {
                inputString = File.ReadAllText(fileName);
            }
            catch (Exception error)
            {
                Console.WriteLine("Error: InputAsString() - {0}\n", error.Message);
                return null;
            }

            return inputString;
        }

        /*
         * For mixed file formats (eg. PDF)
         */
        public static byte[] InputAsBytes(string fileName, string outDirectory)
        {
            byte[] inputBytes;
            try
            {
                inputBytes = File.ReadAllBytes(fileName);
            }
            catch (Exception error)
            {
                Console.WriteLine("Error: InputAsBytes() - {0}\n", error.Message);
                return null;
            }

            return inputBytes;
        }

    }
}
